diff -ruN u-boot-2015.01.old/board/sunxi/dram_olimex_a13_som.c u-boot-2015.01/board/sunxi/dram_olimex_a13_som.c
--- u-boot-2015.01.old/board/sunxi/dram_olimex_a13_som.c	1970-01-01 01:00:00.000000000 +0100
+++ u-boot-2015.01/board/sunxi/dram_olimex_a13_som.c	2015-01-18 15:47:48.738831189 +0100
@@ -0,0 +1,31 @@
+/* this file is generated, don't edit it yourself */
+
+#include <common.h>
+#include <asm/arch/dram.h>
+
+static struct dram_para dram_para = {
+	.clock = 408,
+	.type = 3,
+	.rank_num = 1,
+	.density = 4096,
+	.io_width = 16,
+	.bus_width = 16,
+	.cas = 9,
+	.zq = 123,
+	.odt_en = 0,
+	.size = 512,
+	.tpr0 = 0x42d899b7,
+	.tpr1 = 0xa090,
+	.tpr2 = 0x22a00,
+	.tpr3 = 0,
+	.tpr4 = 0,
+	.tpr5 = 0,
+	.emr1 = 0,
+	.emr2 = 0x10,
+	.emr3 = 0,
+};
+
+unsigned long sunxi_dram_init(void)
+{
+	return dramc_init(&dram_para);
+}
diff -ruN u-boot-2015.01.old/board/sunxi/Kconfig u-boot-2015.01/board/sunxi/Kconfig
--- u-boot-2015.01.old/board/sunxi/Kconfig	2015-01-18 12:48:11.743510311 +0100
+++ u-boot-2015.01/board/sunxi/Kconfig	2015-01-18 15:48:36.594046646 +0100
@@ -130,6 +130,10 @@
 	bool "MINI_X"
 	depends on MACH_SUN4I
 
+config TARGET_OLIMEX_A13_SOM
+	bool "OLIMEX_A13_SOM"
+	depends on MACH_SUN5I
+
 config TARGET_BA10_TV_BOX
 	bool "BA10_TV_BOX"
 	depends on MACH_SUN4I
diff -ruN u-boot-2015.01.old/board/sunxi/Makefile u-boot-2015.01/board/sunxi/Makefile
--- u-boot-2015.01.old/board/sunxi/Makefile	2015-01-18 12:48:11.747510246 +0100
+++ u-boot-2015.01/board/sunxi/Makefile	2015-01-18 15:48:04.894566330 +0100
@@ -32,6 +32,7 @@
 obj-$(CONFIG_TARGET_MELE_M3)		+= dram_sun7i_384_1024_iow16.o
 obj-$(CONFIG_TARGET_MINI_X)		+= dram_sun4i_360_512.o
 obj-$(CONFIG_TARGET_MINI_X_1GB)		+= dram_sun4i_360_1024_iow16.o
+obj-$(CONFIG_TARGET_OLIMEX_A13_SOM)	+= dram_olimex_a13_som.o
 obj-$(CONFIG_TARGET_PCDUINO)		+= dram_sun4i_408_1024_iow8.o
 obj-$(CONFIG_TARGET_PCDUINO3)		+= dram_linksprite_pcduino3.o
 obj-$(CONFIG_TARGET_QT840A)		+= dram_sun7i_384_512_busw16_iow16.o
diff -ruN u-boot-2015.01.old/configs/OLIMEX_A13_SOM_defconfig u-boot-2015.01/configs/OLIMEX_A13_SOM_defconfig
--- u-boot-2015.01.old/configs/OLIMEX_A13_SOM_defconfig	1970-01-01 01:00:00.000000000 +0100
+++ u-boot-2015.01/configs/OLIMEX_A13_SOM_defconfig	2015-01-18 16:25:11.908986082 +0100
@@ -0,0 +1,7 @@
+CONFIG_SPL=y
+CONFIG_SYS_EXTRA_OPTIONS="CONS_INDEX=2,NO_AXP,USB_EHCI"
+CONFIG_FDTFILE="sun5i-a13-olinuxino.dtb"
++S:CONFIG_ARM=y
++S:CONFIG_ARCH_SUNXI=y
++S:CONFIG_MACH_SUN5I=y
++S:CONFIG_TARGET_OLIMEX_A13_SOM=y
